%global buildforkernels current
%global debug_package %{nil}
%global __os_install_post %{nil}

Name:           stk83xx-kmod
Summary:        Kernel module (kmod) for crystalhd
Version:        0.1
Release:        8%{?dist}
License:        GPLv2
URL:            https://github.com/kwizart/crystalhd
Source0:        stk83xx.tar.gz
Patch0:         stk83xx.diff
Patch1:         0001-Added-include-linux-vmalloc.h.patch
# get the needed BuildRequires (in parts depending on what we build for)
BuildRequires:  %{_bindir}/kmodtool
%{!?kernels:BuildRequires: buildsys-build-msvsphere-kerneldevpkgs-%{?buildforkernels:%{buildforkernels}}%{!?buildforkernels:current}-%{_target_cpu} }
%{?fedora:BuildRequires: unifdef}

BuildRequires: gcc
BuildRequires: make
BuildRequires: elfutils-libelf-devel

ExclusiveArch: x86_64

# kmodtool does its magic here
%{expand:%(kmodtool --target %{_target_cpu} --repo msvsphere --kmodname %{name} %{?buildforkernels:--%{buildforkernels}} %{?kernels:--for-kernels "%{?kernels}"} 2>/dev/null) }

%description
CrystalHD extra modules.

%prep
# error out if there was something wrong with kmodtool
%{?kmodtool_check}
# print kmodtool output for debugging purposes:
kmodtool  --target %{_target_cpu} --repo msvsphere --kmodname %{name} %{?buildforkernels:--%{buildforkernels}} %{?kernels:--for-kernels "%{?kernels}"} 2>/dev/null

%setup -q -c
pushd stk83xx
%patch -P0 -p1 -b .fix-segfault
%patch -P1 -p1 -b .fix-build-on-new-kernels
popd
#Copied from kernel sources
pwd
ls

for kernel_version in %{?kernel_versions} ; do
        cp -a stk83xx _kmod_build_${kernel_version%%___*}
done


%build
for kernel_version  in %{?kernel_versions} ; do
%make_build -C ${kernel_version##*___} \
  M=${PWD}/_kmod_build_${kernel_version%%___*} \
  modules
done


%install
for kernel_version in %{?kernel_versions}; do
 mkdir -p ${RPM_BUILD_ROOT}%{kmodinstdir_prefix}/${kernel_version%%___*}/%{kmodinstdir_postfix}/
 install -D -m 755 -t ${RPM_BUILD_ROOT}%{kmodinstdir_prefix}/${kernel_version%%___*}/%{kmodinstdir_postfix}/ $(find _kmod_build_${kernel_version%%___*}/ -name '*.ko')
done

# Fix for the SB-signing issue caused by a bug in /usr/lib/rpm/brp-strip
# https://bugzilla.redhat.com/show_bug.cgi?id=1967291
find %{buildroot} -name \*.ko -type f | xargs --no-run-if-empty %{__strip} --strip-debug

# Sign the modules(s)
%if %{?_with_modsign:1}%{!?_with_modsign:0}
for kernel_version in %{?kernel_versions}; do
    # If the module signing keys are not defined, define them here.
    %{!?privkey: %define privkey %{_sysconfdir}/pki/kmod/msvsphere_kmod.priv}
    %{!?pubkey: %define pubkey %{_sysconfdir}/pki/kmod/msvsphere_kmod.pem}
    for module in $(find %{buildroot} -type f -name \*.ko);
        do %{_usrsrc}/kernels/${kernel_version%%___*}/scripts/sign-file \
            sha256 %{privkey} %{pubkey} $module;
    done
done
%endif

%{?akmod_install}


%changelog
* Fri Apr 11 2025 Arkady L. Shane <tigro@msvsphere-os.ru> - 0.1-8
- Rebuilt against kernel 6.12.0-55.6.1.el10_0

* Tue Feb 04 2025 Arkady L. Shane <tigro@msvsphere-os.ru> - 0.1-7
- Fix build for MSVSphere 10

* Sat Nov 16 2024 Arkady L. Shane <tigro@msvsphere-os.ru> - 0.1-6
- Update to kernel-5.14.0-503.11.1.el9_5

* Mon Oct 21 2024 Arkady L. Shane <tigro@msvsphere-os.ru> - 0.1-5
- Rebuilt for kernel-5.14.0-503.2.1.el9_5

* Tue Oct 15 2024 Arkady L. Shane <tigro@msvsphere-os.ru> - 0.1-4
- Fix segfaults during suspend

* Fri Aug 02 2024 Arkady L. Shane <tigro@msvsphere-os.ru> - 0.1-3
- Added condition for signing

* Thu Aug 01 2024 Arkady L. Shane <tigro@msvsphere-os.ru> - 0.1-2
- Added sign options

* Wed Jun 05 2024 Arkady L. Shane <tigro@msvsphere-os.ru> - 0.1-1.1
- Rebuilt against new kernel version

* Wed Jun 05 2024 Arkady L. Shane <tigro@msvsphere-os.ru> - 0.1-1
- Rebuilt for MSVSphere 9.4

